package com.sodius.mdw.log;

import java.util.Collection;

/**
 * @author Mickael Albert
 * Defines the context where happened an event
 */
public interface EventContext {

	
	/**
	 * @return the list of keys defining properties of this context
	 */
	public Collection<String> getKeys();
	
	
	/**
	 * @param key
	 * @return true if the property key was valuated
	 */
	public boolean hasValue(String key);
	
	
	/**
	 * @param key
	 * @return the value of the property key
	 */
	public Object getValue(String key);
	
	
	/**
	 * @param key
	 * @return the String representation of property key. Null if not valuated
	 */
	public String getValueDescription(String key);
	
	
	/**
	 * @return A short String representation of this context. Useful for summarizing the event.
	 */
	public String getSimpleName();
	
	
	/**
	 * @return The URL of this context. Null if not available.
	 */
	public String getURL();
}
