package com.sodius.mdw.log.context;

import java.util.Arrays;
import java.util.Collection;
import java.util.List;

/**
 * @author Mickael Albert
 * Context describing a location in a RuleSet
 *
 */
public class RuleContext extends GenericEventContext {

	public static final String KEY_RULESET_NAME="RULESET_NAME";
	public static final String KEY_RULE_NAME="RULE_NAME";
	protected static final List<String> keys = Arrays.asList(new String[]{KEY_RULESET_NAME, KEY_RULE_NAME});
	
	public RuleContext(String ruleSetName, String ruleName) {
		super();
		key2value.put(KEY_RULESET_NAME, ruleSetName);
		key2value.put(KEY_RULE_NAME, ruleName);
	}

	@Override
	public Collection<String> getKeys() {
		return keys;
	}
	
	@Override
	public String toString() {
		return getValue(KEY_RULESET_NAME)+"."+getValue(KEY_RULE_NAME);
	}
	
	public static RuleContext create(String ruleSetName, String ruleName)
	{
		return new RuleContext(ruleSetName, ruleName);
	}
}
