package com.sodius.rhapsody.licensing;

import java.io.File;

import com.sodius.mdw.core.model.io.ConnectorDescriptor;
import com.sodius.mdw.corext.app.ApplicationProvider;
import com.sodius.mdw.corext.app.InternalApplication;
import com.sodius.mdw.corext.security.LicenseAdapter;
import com.sodius.mdw.corext.security.LicenseData;
import com.sodius.mdw.corext.security.LicenseException;
import com.sodius.mdw.corext.security.LicenseFeature;

public class XMIApplicationProvider implements ApplicationProvider {

    public InternalApplication createApplication() {
        return new InternalApplication() {

            public String getID() {
                return "RPXMI";
            }

            public String getName() {
                return "Rhapsody XMI Toolkit";
            }};
    }

    public LicenseAdapter createLicenseAdapter() {
         return new LicenseAdapter() {

            public void checkin(LicenseData arg0) {
            }

            public LicenseData checkout(LicenseFeature arg0) throws SecurityException {
                return new LicenseData(arg0);
            }

            public LicenseData checkoutConnector(String arg0, ConnectorDescriptor arg1) throws SecurityException {
                return new LicenseData(new LicenseFeature("XMI.connector", "1.0"));
            }

            public LicenseData checkoutDeployProject() throws SecurityException {
                return new LicenseData(new LicenseFeature("XMI.Deploy", "1.0"));
            }

            public LicenseData checkoutIDE() throws SecurityException {
                throw new LicenseException("No license for XMI Toolkit Rules Editor.");
            }

            public LicenseData checkoutImportMetamodel() throws SecurityException {
                throw new LicenseException("No license for XMI Toolkit Import Metamodel.");
            }

            public LicenseData checkoutImportRulesComposer() throws SecurityException {
                throw new LicenseException("No license for XMI Toolkit Import.");
            }

            public LicenseData checkoutLaunchEvaluation() throws SecurityException {
                return new LicenseData(new LicenseFeature("RPXMI", "1.0"));
            }

            public LicenseData checkoutLaunchEvaluation(File arg0) throws SecurityException {
                return new LicenseData(new LicenseFeature("RPXMI", "1.0"));
            }

            public LicenseData checkoutMetamodel(String arg0, boolean arg1) throws SecurityException {
                return new LicenseData(new LicenseFeature("XMI.metamodel", "1.0"));
            };
         };
    }

}
