package com.sodius.rhapsody.mdw;

import java.io.File;
import java.io.FileFilter;
import java.net.MalformedURLException;
import java.net.URI;
import java.net.URL;

import com.sodius.mdw.corext.util.ClassLocator;
import com.sodius.rhapsody.toolkit.XMIToolkitApplication;
import com.sodius.rhapsody.toolkit.util.FileUtils;
import com.telelogic.rhapsody.core.RhapsodyAppServer;

public class XMIToolkitPlugin {

	private static int irpApplication = 0;
	public static boolean isExport = true;
	
	public static void RhpPluginInvokeItem() {
		if (irpApplication == 0) {
			System.out.println("Rhapsody Application is not set.  Cannot start Rhapsody XMI Toolkit.");
			return;
		}
        String installDir = "";
        try {
	        try {
	            installDir = new File(URI.create(ClassLocator.getSourceLocation(XMIToolkitPlugin.class).toString()).getPath()).getParentFile().getParentFile().getAbsolutePath(); 
	        } catch (Exception e) {
	            System.out.println("Error finding source location.  Using OMROOT location to derive install directory.");
	            e.printStackTrace();
	            try {//TODO : user RhapsodyAPIExec
	            	installDir = new File(new File(RhapsodyAppServer.attachToRhapsodyApplication(irpApplication).getOMROOT()).getParentFile(), "Sodius/XMI_Toolkit").getAbsolutePath();
	            } catch (Exception ex) {
	                System.out.println("Error finding source location using OMROOT location.");
	                throw ex;
	            }
	        }


			String [] args = new String[] {"-toolkit.directory", installDir, 
					"-mode", isExport? "EXPORT" : "IMPORT", "-asPlugin", String.valueOf(irpApplication)};
			
			new XMIToolkitApplication().run(args);
		
/*	        // use my classloader
	        URL [] urls = getClassPath(installDir);
	        ClassLoader myLoader = new URLClassLoader(urls);
	        Exception ex = null;
	        try {
	            Class rc = Class.forName("com.sodius.rhapsody.toolkit.RhapsodyXMIToolkit", true, myLoader);
	            Method method = rc.getMethod("main", new Class[] { args.getClass() });
	            method.invoke(null, new Object[] {args});
	        } catch (ClassNotFoundException e) {    
	            ex = e;
	        } catch (SecurityException e) {
	            ex = e;
	        } catch (NoSuchMethodException e) {
	            ex = e;
	        } catch (IllegalArgumentException e) {
	            ex = e;
	        } catch (IllegalAccessException e) {
	            ex = e;
	        } catch (InvocationTargetException e) {
	            ex = e;
	        }
	        if (ex != null) {
	            System.out.println("Error invoking XMIToolkit.");
	            ex.printStackTrace();
	        }
*/	    } catch (Throwable e) {
	        System.out.println("Error in RulesComposer Plugin.");
	        e.printStackTrace();
	    }
	
	}

	private static URL[] getClassPath(String installDir) {
		
		File[] jarFiles = FileUtils.findFiles(new File(installDir), new FileFilter() {

			public boolean accept(File pathname) {
				if (pathname.isDirectory()) return true;
				return pathname.getName().endsWith(".jar");
			}});
	    URL[] urls = new URL[jarFiles.length];
		for (int i = 0; i < jarFiles.length; i++) {
			try {
				urls[i] = jarFiles[i].toURL();
			} catch (MalformedURLException e) {
				e.printStackTrace();
			}
		}
	    return urls;
	    
	}

	 
	public static void RhpPluginInit(int nativeIRPApp) {
        irpApplication = nativeIRPApp;
	}
	 
	 
}
