/*
 * Created on Jun 29, 2004
 */
package com.sodius.rhapsody.toolkit.properties;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

/**
 * @author xavier
 */
public class RhapsodyTagsReader {

	private String rhapsodyTagsFile = "";
	private Properties rhapsodyTags;

	static public RhapsodyTagsReader EMPTY_TAGS_READER = new RhapsodyTagsReader();
	
	private RhapsodyTagsReader() {
		rhapsodyTags = new Properties();
	}

	public RhapsodyTagsReader(String rhapsodyTagsFile) throws IOException {
		this.rhapsodyTagsFile = rhapsodyTagsFile;
		this.reloadRhapsodyTags();
	}

	public void setTagsFile(String rhapsodyTagsFile) throws IOException  {
		this.rhapsodyTagsFile = rhapsodyTagsFile;
		this.reloadRhapsodyTags();
	}
	
	public String getTagsFile() {
		return rhapsodyTagsFile;
	}
		
	public void reloadRhapsodyTags() throws IOException {
		rhapsodyTags = new Properties();
		//try {
			InputStream is = new FileInputStream(rhapsodyTagsFile);
			rhapsodyTags.load(is);
			is.close();
		//} catch (FileNotFoundException e) {
			
		//}
	}	

	public boolean shouldBeExported (String fullTagName) {
		if ( rhapsodyTags.containsKey(fullTagName) ) {
			 return true;
		}		
		return false;
	}	
}
