package com.sodius.rhapsody.toolkit.ui;

import org.eclipse.core.runtime.IProgressMonitor;

import com.sodius.mdw.core.util.progress.ProgressMonitor;

public class EclipseProgressMonitor implements ProgressMonitor {

    private IProgressMonitor monitor;
    
    public EclipseProgressMonitor(IProgressMonitor monitor) {
        this.monitor = monitor;
    }
    
    public boolean isCanceled() {
        return monitor.isCanceled();
    }
    
    public void setCanceled(boolean value) {
        monitor.setCanceled(value);
    }

    public void beginTask(String name, int totalWork) {
        monitor.beginTask(name, totalWork);
    }

    public void done() {
        monitor.done();
    }

    public void internalWorked(double work) {
        monitor.internalWorked(work);
    }

    public void setTaskName(String name) {
        monitor.setTaskName(name);
    }

    public void subTask(String name) {
        monitor.subTask(name);
    }

    public void worked(int work) {
        monitor.worked(work);
    }

}