package com.sodius.rhapsody.toolkit.ui;

import org.eclipse.swt.widgets.Composite;

import com.sodius.rhapsody.toolkit.properties.RhapsodyXMIToolkitParameters;

public class ImportLoadFileWizardPage extends ToolkitWizardSelectionPage {

    private final String loadFilePageLabel;
    private static String DESCRIPTION = "Select XMI file to import in Rhapsody";

    ImportUML21WizardNode importUML21WizardNode;
    ImportLoadFileControl importLoadFileControl;

    ImportLoadFileWizardPage(ToolkitUIManager manager, String pageLabel) {
        super(manager, "ImportLoadFileWizardPage", pageLabel, manager.getImageRegistry().getDescriptor(manager.getIconFileName()));
        setDescription(DESCRIPTION);
        this.loadFilePageLabel = pageLabel;
    }

    public void createControl(Composite parent) {
        importLoadFileControl = new ImportLoadFileControl(parent, this, this.manager, loadFilePageLabel);
        setControl(importLoadFileControl);
        getImportUML21WizardNode(); // @See RTC 124781
        manageAutomaticPageComplete();
    }

    protected ImportUML21WizardNode getImportUML21WizardNode() {
        if (importUML21WizardNode == null) {
            importUML21WizardNode = new ImportUML21WizardNode(manager);
        }
        return importUML21WizardNode;
    }

    void setIsUML21WizardNode(boolean is) {
        if (is) {
            setSelectedNode(getImportUML21WizardNode()); // @See RTC 124781
        } else {
            setSelectedNode(null);
        }
    }

    public boolean isCommandLineFilled() {
        return (this.manager.getToolkit().getParameters().isCommandLineProperty(RhapsodyXMIToolkitParameters.KEY_XMI_FILENAME));
    }

    public void setParameters() {
        // TODO Auto-generated method stub

    }
}
