package com.sodius.rhapsody.toolkit.ui;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

import com.sodius.rhapsody.toolkit.properties.RhapsodyXMIToolkitParameters;

public class ImportMethodControl extends Composite {

	private Map<RhapsodyXMIToolkitParameters.importMethodKind, Button> methods;
	protected ToolkitWizardPage page;
	protected ToolkitUIManager manager;

	public ImportMethodControl(Composite parent, ToolkitWizardPage page, ToolkitUIManager manager) {
		super(parent, SWT.NONE);
		this.page = page;
		this.manager = manager;
		this.setLayout(new GridLayout(1, false));
		this.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		
		createContent();

	}

	protected void createContent() {
		createFields();
		registerListener();
	}
	
	protected void createFields() {
		
		methods = new HashMap<RhapsodyXMIToolkitParameters.importMethodKind, Button>();
		
		Button add = new Button(this, SWT.RADIO);
		add.setText(RhapsodyXMIToolkitParameters.importMethodKind.ADD.literal);
		methods.put(RhapsodyXMIToolkitParameters.importMethodKind.ADD, add);

		Button addReplace = new Button(this, SWT.RADIO);
		addReplace.setText(RhapsodyXMIToolkitParameters.importMethodKind.ADD_AND_REPLACE.literal);
		methods.put(RhapsodyXMIToolkitParameters.importMethodKind.ADD_AND_REPLACE, addReplace);
		
		Button diffMerge = new Button(this, SWT.RADIO);
		diffMerge.setText(RhapsodyXMIToolkitParameters.importMethodKind.DIFFMERGE.literal);
		methods.put(RhapsodyXMIToolkitParameters.importMethodKind.DIFFMERGE, diffMerge);
		
		add.setSelection(true);
		
		SelectionListener listener = new SelectionListener() {
		
			public void widgetSelected(SelectionEvent e) {
				page.setParameters();
			}
		
			public void widgetDefaultSelected(SelectionEvent e) {
				// TODO Auto-generated method stub
			}
		
		};
		add.addSelectionListener(listener);
		addReplace.addSelectionListener(listener);
		diffMerge.addSelectionListener(listener);
	}

	protected void registerListener() {
		this.addHelpListener(manager.getHelpListener());
	}

	public RhapsodyXMIToolkitParameters.importMethodKind getImportMethod() {
		for (RhapsodyXMIToolkitParameters.importMethodKind importMethodkind : methods.keySet()) {
			if (methods.get(importMethodkind).getSelection())
				return importMethodkind;
		}
		return null;
	}

	public static RhapsodyXMIToolkitParameters.importMethodKind getADD_METHOD() {
		return RhapsodyXMIToolkitParameters.importMethodKind.ADD;
	}

}
