package com.sodius.rhapsody.toolkit.ui;

import org.eclipse.swt.widgets.Composite;

import com.sodius.rhapsody.toolkit.properties.RhapsodyXMIToolkitParameters;

public class ImportMethodWizardPage extends ToolkitWizardPage{

	private static String titleLabel = "Select how elements are imported into Rhapsody";
	private ImportMethodControl importMethod;

	ImportMethodWizardPage(ToolkitUIManager manager, String pageTitle) {
		super(manager, "ImportMethodWizardPage", pageTitle, manager.getImageRegistry().getDescriptor(manager.getIconFileName()));
		setDescription(titleLabel);
	}

	public void createControl(Composite parent) {
		importMethod = new ImportMethodControl(parent, this, this.manager);
		setControl(importMethod);
	}

	public void setParameters() {
		RhapsodyXMIToolkitParameters parameters = manager.getToolkit().getParameters();
		parameters.setImportMethod(importMethod.getImportMethod());
	}

	public boolean isCommandLineFilled() {
		return this.manager.getToolkit().getParameters().isCommandLineProperty(RhapsodyXMIToolkitParameters.KEY_AUTO_MERGE);
	}

}
