package com.sodius.rhapsody.toolkit.ui;

import org.eclipse.jface.wizard.WizardPage;



public class ImportUML21Wizard extends ToolkitWizard {

	private static String importMethodPageTitle = "Select import method";
	private static String unitsSelectionPageTitle = "Units selection";
	private ImportMethodWizardPage importMethodPage ;


	ImportUML21Wizard(ToolkitUIManager manager) {
		super(manager);
		setWindowTitle(manager.getToolkit().getParameters().getCustomization().name + " importer"); 
	}

	public void addPages() {
		if(!isPagesReady())
		{
			mainPage = new ImportUnitsSelectionWizardPage(this.manager, unitsSelectionPageTitle);
			importMethodPage =  new ImportMethodWizardPage(this.manager, importMethodPageTitle);
			if(!((ImportUnitsSelectionWizardPage)mainPage).isCommandLineFilled())
				super.addPage(mainPage);
			else
				mainPage=importMethodPage;
			if(!importMethodPage.isRecursiveCommandLineFilled())
				super.addPage(importMethodPage);
		}
	}
	
	public WizardPage getUnitsSelectionPage() {
		return mainPage;
	}

	public ImportMethodWizardPage getImportMethodMage() {
		return importMethodPage;
	}

}
