package com.sodius.rhapsody.toolkit.ui;

import com.sodius.mdw.core.CoreException;
import com.sodius.mdw.core.util.log.AbstractLogger;
import com.sodius.mdw.core.util.log.Level;
import com.sodius.rhapsody.toolkit.engine.XMIEngine;
import com.sodius.rhapsody.toolkit.util.thread.RhapsodyAPIExec;

public class RhapsodyConsolLogger extends AbstractLogger {

	private XMIEngine engine;

	private boolean emptyLog = true;
	
	public RhapsodyConsolLogger(XMIEngine engine) {
		this.engine = engine;
	}

	protected void log(Level level, final Object message, Throwable error) {
		if (message != null) {
			if(!level.isInfo() && !level.isDebug())
				emptyLog = false;
        	try {
				RhapsodyAPIExec.synchExec(new Runnable() {
					
					public void run() {
						engine.getApplication().writeToOutputWindow("Toolkit", message.toString()+"\n");
					}
				
				});
			} catch (CoreException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
	public boolean isEmpty() {
		return emptyLog;
	}

}
