package com.sodius.rhapsody.toolkit.ui;

import org.eclipse.swt.widgets.Shell;

import com.sodius.mdw.core.OperationCanceledException;
import com.sodius.mdw.core.util.progress.ProgressMonitor;
import com.sodius.rhapsody.toolkit.engine.XMIEngine;

class XMITask {
	
	private RhapsodyXMIToolkit owner;
	private XMIEngine engine;

	public XMITask(RhapsodyXMIToolkit toolkit, XMIEngine engine) {
		this.owner = toolkit;
		this.engine = engine;
	}

	public void run(ProgressMonitor monitor) throws Throwable {
		try {
			monitor.beginTask("", -1);
			engine.run(monitor);
			
			if (monitor.isCanceled()) {
				return;
			}
			monitor.done();
		}

		catch (OperationCanceledException e) {
			monitor.done();
		} 
		catch (Throwable e) {
			monitor.done();
			throw e;
		} 
	}

}
