package com.sodius.rhapsody.toolkit.util;

import java.io.File;
import java.io.FileFilter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class FileUtils {

    /**
     * Returns the files matching the filter.  The filter must return true for directories
     * in order to be recursive.
     * 
     * @param parentFile
     * @param filter
     * @return the files which pass the filter and are not directories
     */
    public static File[] findFiles(File parentFile, FileFilter filter) {
    	List files = new ArrayList();
    	File [] subFiles = parentFile.listFiles(filter);
    	for (int i = 0; i < subFiles.length; i++) {
			File f = subFiles[i];
			if (f.isDirectory()) {
				File[] subResult = findFiles(f, filter);
				files.addAll(Arrays.asList(subResult));
			} else {
				files.add(f);
			}
		}
    	return (File[]) files.toArray(new File[0]);
    }

	public static void move(File srcFile, File destFile) {
		srcFile.renameTo(destFile);
	}
}
