package com.sodius.rhapsody.toolkit.util;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;

import com.sodius.mdw.core.util.log.Logger;

public class PrintStreamLogger extends PrintStream {

    private static final OutputStream NULL_STREAM = new OutputStream() {
        
        public void write(int b) {
            // ignore
        }
    
        public void write(byte[] b) {
            // ignore
        }
    
        public void write(byte[] b, int off, int len) {
            // ignore
        }
    
        public void flush() {
            // ignore
        }
    
        public void close() {
            // ignore
        }
    };
    
	private Logger logger;
	private boolean isErr;

	public PrintStreamLogger(Logger logger, boolean isErrStream) {
		super(NULL_STREAM);
		this.logger = logger;
		this.isErr = isErrStream;
	}

	public void close() {
	}

	public void flush() {
	}

	public void print(boolean b) {
		log(String.valueOf(b));
	}

	public void print(char c) {
		log(String.valueOf(c));
	}

	public void print(char[] s) {
		log(String.valueOf(s));
	}

	public void print(double d) {
		log(String.valueOf(d));
	}

	public void print(float f) {
		log(String.valueOf(f));
	}

	public void print(int i) {
		log(String.valueOf(i));
	}

	public void print(long l) {
		log(String.valueOf(l));
	}

	public void print(Object obj) {
		log(obj);
	}

	public void print(String s) {
		log(s);
	}

	public void println(String x) {
		log(x);
	}

	public void println() {
		log(""); //$NON-NLS-1$
	}

	public void println(boolean x) {
		log(String.valueOf(x));
	}

	public void println(char x) {
		log(String.valueOf(x));
	}

	public void println(char[] x) {
		log(String.valueOf(x));
	}

	public void println(double x) {
		log(String.valueOf(x));
	}

	public void println(float x) {
		log(String.valueOf(x));
	}

	public void println(int x) {
		log(String.valueOf(x));
	}

	public void println(long x) {
		log(String.valueOf(x));
	}

	public void println(Object x) {
		log(String.valueOf(x));
	}

	public void write(byte[] b) throws IOException {
		log(new String(b));
	}

	public void write(byte[] buf, int off, int len) {
		log(new String(buf, off, len));
	}

	public void write(int b) {
		log(Integer.valueOf(b + ""));
	}

	private void log(Object message) {
		if (this.isErr)
			this.logger.error(message);
		else
			this.logger.info(message);
	}

}
